<template>
  <q-page class="text-center">
    <div class="q-pa-md">
      <h2>This is your first login. Please choose your own password:</h2>
      <div>
        <q-input
          v-model="password"
          filled
          type="password"
          label="NewPassword"
          @keyup.enter="submit"
        />
        <q-input
          v-model="verify"
          filled
          type="password"
          label="VerifyPassword"
          @keyup.enter="submit"
        />
      </div>
      <div>
        <q-btn
          class="q-ma-md"
          color="black"
          text-color="white"
          label="Log In"
          @click="submit"
        />
      </div>
    </div>
  </q-page>
</template>

<script>
import { api } from "boot/axios";
import axios from "axios";
import { mapMutations } from "vuex";

export default {
  name: "LoginPage",
  data() {
    return {
      password: "",
      verify: ""
    };
  },
  methods: {
    async submit(event) {
      //event.preventDefault();
      let errors = [];

      if (!this.password) {
        this.$q.notify({
          color: "red-5",
          textColor: "white",
          icon: "warning",
          message: "Enter password"
        });
        errors.push("No password");
      }
      if (!this.verify) {
        this.$q.notify({
          color: "red-5",
          textColor: "white",
          icon: "warning",
          message: "Verify password"
        });
        errors.push("Skipped verification");
      }

      if (this.password !== this.verify) {
        this.$q.notify({
          color: "red-5",
          textColor: "white",
          icon: "warning",
          message: "The two fields must match"
        });
        errors.push("Verification");
      }

      if (errors.length === 0) {
        const reqData = {
          newPassword: this.password,
          token: sessionStorage.getItem("token")
        };
        await api
          .post("/api/user/changePassword", reqData)
          .then(res => {
            if (res.status === 202) {
              this.$router.push("/home");
            }
          })
          .catch(error => {
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: error.response.data.message
            });
          });
      }
    }
  }
};
</script>

<style scoped>
.q-btn {
}
.header {
  text-align: center;
}
</style>
